# TODO
# - verify %lang codes
%define		modname	xcache
Summary:	%{modname} - PHP opcode cacher
Summary(pl.UTF-8):	%{modname} - buforowanie opcodów PHP
Name:		php-%{modname}
Version:	3.0.0
Release:	0.6
License:	BSD
Group:		Development/Languages/PHP
URL:		http://xcache.lighttpd.net/
Source0:	http://xcache.lighttpd.net/pub/Releases/%{version}/xcache-%{version}.tar.bz2
# Source0-md5:	63be7c8b14ffc01babe5378111f13228
Source1:	%{modname}-apache.conf
Source2:	%{modname}-lighttpd.conf
Patch0:		config.patch
BuildRequires:	php-devel >= 4:5.2.17-8
BuildRequires:	rpmbuild(macros) >= 1.344
BuildRequires:	sed >= 4.0
%{?requires_zend_extension}
Requires:	php(core) >= 5.0.4
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_webapps	/etc/webapps
%define		_webapp		%{modname}
%define		_sysconfdir	%{_webapps}/%{_webapp}
%define		_appdir		%{_datadir}/%{_webapp}

%description
XCache is a fast, stable PHP opcode cacher that has been tested and is
now running on production servers under high load.

%description -l pl.UTF-8
XCache to szybkie, stabilne buforowanie opcodów PHP, przetestowane i
działające na produkcyjnych serwerach o dużym obciążeniu.

%package web
Summary:	WEB interface for xCache
Group:		Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	webapps
Requires:	webserver(php) >= 5.0

%description web
Via this web interface script you can manage and view statistics of
xCache.

More information you can find at %{url}.

%prep
%setup -q -n %{modname}-%{version}
%patch0 -p1
%{__sed} -i.bak -e '
	s,@extensiondir@,%{php_extensiondir},
' xcache.ini

mv htdocs/config{.default,}.php
mv htdocs/config.example.php config.example.php
mv htdocs/cacher/config{.default,}.php
mv htdocs/cacher/config.example.php cacher.config.example.php
mv htdocs/coverager/config{.default,}.php
mv htdocs/coverager/config.example.php coverager.config.example.php

%{__rm} htdocs/common/lang/*.po
%{__rm} htdocs/coverager/lang/*.po
%{__rm} htdocs/cacher/lang/*.po

# wtf?
%{__rm} htdocs/diagnosis/lang/zh-tranditional.php

%build
phpize
%configure \
	--enable-xcache \
	--enable-xcache-optimizer \
	--enable-xcache-coverager
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	INSTALL_ROOT=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d
cp -p xcache.ini $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d/%{modname}.ini

# The cache directory where pre-compiled files will reside
install -d $RPM_BUILD_ROOT/var/cache/php-%{modname}

# web app
install -d $RPM_BUILD_ROOT{%{_appdir},%{_sysconfdir}}
cp -a htdocs/* $RPM_BUILD_ROOT%{_appdir}
%{__rm} $RPM_BUILD_ROOT%{_appdir}/diagnosis/lang/*.po

mv $RPM_BUILD_ROOT{%{_appdir},%{_sysconfdir}}/config.php
mv $RPM_BUILD_ROOT{%{_appdir}/cacher/config.php,%{_sysconfdir}/cacher.config.php}
mv $RPM_BUILD_ROOT{%{_appdir}/coverager/config.php,%{_sysconfdir}/coverager.config.php}
ln -s %{_sysconfdir}/config.php $RPM_BUILD_ROOT%{_appdir}/config.php
ln -s %{_sysconfdir}/cacher.config.php $RPM_BUILD_ROOT%{_appdir}/cacher/config.php
ln -s %{_sysconfdir}/coverager.config.php $RPM_BUILD_ROOT%{_appdir}/coverager/config.php
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/apache.conf
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/httpd.conf
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/lighttpd.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post
%php_webserver_restart

%postun
if [ "$1" = 0 ]; then
	%php_webserver_restart
fi

%triggerin web -- apache1 < 1.3.37-3, apache1-base
%webapp_register apache %{_webapp}

%triggerun web -- apache1 < 1.3.37-3, apache1-base
%webapp_unregister apache %{_webapp}

%triggerin web -- apache < 2.2.0, apache-base
%webapp_register httpd %{_webapp}

%triggerun web -- apache < 2.2.0, apache-base
%webapp_unregister httpd %{_webapp}

%triggerin web -- lighttpd
%webapp_register lighttpd %{_webapp}

%triggerun web -- lighttpd
%webapp_unregister lighttpd %{_webapp}

%files
%defattr(644,root,root,755)
%doc AUTHORS README THANKS
%config(noreplace) %verify(not md5 mtime size) %{php_sysconfdir}/conf.d/%{modname}.ini
%attr(755,root,root) %{php_extensiondir}/%{modname}.so

# XXX: what for this dir is used?
%dir %attr(775,root,http) /var/cache/php-xcache

%files web
%defattr(644,root,root,755)
%doc config*.example.php
%dir %attr(750,root,http) %{_sysconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/apache.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/httpd.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/lighttpd.conf
%attr(640,root,http) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/config.php
%attr(640,root,http) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/cacher.config.php
%attr(640,root,http) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/coverager.config.php
%dir %{_appdir}
%{_appdir}/*.php

%dir %{_appdir}/common
%{_appdir}/common/*.css
%{_appdir}/common/*.php
%{_appdir}/common/*.png
%dir %{_appdir}/common/lang
%{_appdir}/common/lang/en.php
%lang(cn) %{_appdir}/common/lang/zh-simplified.php
%lang(cn) %{_appdir}/common/lang/zh-traditional.php

%dir %{_appdir}/cacher
%{_appdir}/cacher/*.css
%{_appdir}/cacher/*.js
%{_appdir}/cacher/*.php
%{_appdir}/cacher/sub
%dir %{_appdir}/cacher/lang
%{_appdir}/cacher/lang/en.php
%lang(zh_CN) %{_appdir}/cacher/lang/zh-simplified.php
%lang(zh_CN) %{_appdir}/cacher/lang/zh-traditional.php

%dir %{_appdir}/coverager
%{_appdir}/coverager/*.css
%{_appdir}/coverager/*.php
%dir %{_appdir}/coverager/lang
%{_appdir}/coverager/lang/en.php
%lang(zh_CN) %{_appdir}/coverager/lang/zh-simplified.php
%lang(zh_CN) %{_appdir}/coverager/lang/zh-traditional.php

%dir %{_appdir}/diagnosis
%{_appdir}/diagnosis/*.css
%{_appdir}/diagnosis/*.php
%dir %{_appdir}/diagnosis/lang
%{_appdir}/diagnosis/lang/en.php
%lang(zh_CN) %{_appdir}/diagnosis/lang/zh-simplified.php
%lang(zh_CN) %{_appdir}/diagnosis/lang/zh-traditional.php
%changelog
* Wed Nov 21 2012 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/php-xcache.git;a=log;h=master

* Wed Nov 21 2012 Elan Ruusamäe <glen@delfi.ee> 6620175
- patch config loading for webapp

* Wed Nov 21 2012 Elan Ruusamäe <glen@delfi.ee> 14119aa
- handle lang and more config files

* Wed Nov 21 2012 Elan Ruusamäe <glen@delfi.ee> 709c007
- up to 3.0.0

* Thu Aug 23 2012 Elan Ruusamäe <glen@delfi.ee> 67844c7
- use php(core) as dependency to require php version
- release 3 (by relup.sh)

* Wed Aug 22 2012 Elan Ruusamäe <glen@delfi.ee> 9d1b109
do not load xcache extension twice

* Mon Aug 06 2012 Elan Ruusamäe <glen@delfi.ee> 6bc5527
- release 2 (by relup.sh)

* Sun Jul 15 2012 Adam Gołębiowski <adamg@pld-linux.org> b1a803d
- updated to 2.0.1

* Tue Jan 31 2012 Elan Ruusamäe <glen@pld-linux.org> 4448cdb
- release 2

* Tue Oct 25 2011 Elan Ruusamäe <glen@pld-linux.org> eeb0712
- up to 1.3.2

* Mon May 23 2011 lisu <lisu@pld-linux.org> 22a2428
- rel 3

* Fri Feb 11 2011 Elan Ruusamäe <glen@pld-linux.org> c7a041c
- release 2

* Fri Feb 11 2011 areq <areq@pld-linux.org> b5060c6
- 1.3.1

* Sat Dec 11 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> b011b88
- release 3

* Thu Jun 03 2010 Elan Ruusamäe <glen@pld-linux.org> d62ebf8
- release 2

* Tue Sep 08 2009 Paweł Gołaszewski <blues@pld-linux.org> 33170e7
- 1.3.0 (Stacho Pal <stacho@venco.com.pl>)

* Thu Nov 13 2008 Elan Ruusamäe <glen@pld-linux.org> 12051c0
- release 3

* Thu Nov 13 2008 Elan Ruusamäe <glen@pld-linux.org> e35cf76
- -web subpackage

* Wed Jan 30 2008 dzeus <dzeus@pld-linux.org> 4d01436
- up to 1.2.2

* Thu Sep 20 2007 dzeus <dzeus@pld-linux.org> 44fec13
- packaged lighttpd.conf, rel. 4, STBR

* Mon Sep 17 2007 Elan Ruusamäe <glen@pld-linux.org> 8eff491
- add lighttpd integration; rel 3

